Index: /LMDZ4/trunk/libf/phylmd/traclmdz_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/traclmdz_mod.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/traclmdz_mod.F90	(revision 1403)
@@ -6,4 +6,6 @@
 ! only if running without any other chemestry model as INCA or REPROBUS.  
 !
+
+  IMPLICIT NONE
 
   REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: masktr   ! Masque reservoir de sol traceur
@@ -35,4 +37,18 @@
 !$OMP THREADPRIVATE(id_be)
 
+!IM ajout traceurs RR 
+  INTEGER,SAVE :: id_dry !traceur dry intrusions
+!$OMP THREADPRIVATE(id_dry)
+  INTEGER,SAVE :: id_pcsat, id_pcocsat, id_pcq ! traceurs pseudo-vapeur CL qsat, qsat_oc, q
+!$OMP THREADPRIVATE(id_pcsat, id_pcocsat, id_pcq)
+  INTEGER,SAVE :: id_pcs0, id_pcos0, id_pcq0 ! traceurs pseudo-vapeur CL qsat, qsat_oc, q
+!                                            ! qui ne sont pas transportes par la convection
+!$OMP THREADPRIVATE(id_pcs0, id_pcos0, id_pcq0)
+
+  INTEGER, SAVE:: id_o3
+  !$OMP THREADPRIVATE(id_o3)
+  ! index of ozone tracer with Cariolle parameterization
+  ! 0 means no ozone tracer
+
   LOGICAL,SAVE :: rnpb=.TRUE. ! Presence du couple Rn222, Pb210
 !$OMP THREADPRIVATE(rnpb)
@@ -47,5 +63,4 @@
     USE dimphy
     USE infotrac
-    IMPLICIT NONE
     
     ! Input argument
@@ -65,11 +80,11 @@
 
 
-  SUBROUTINE traclmdz_init(pctsrf, ftsol, tr_seri, aerosol, lessivage)
+  SUBROUTINE traclmdz_init(pctsrf, ftsol, tr_seri, t_seri, pplay, sh, aerosol, lessivage)
     ! This subroutine allocates and initialize module variables and control variables.
     USE dimphy
     USE infotrac
+    USE regr_pr_comb_coefoz_m, ONLY: alloc_coefoz
+    USE press_coefoz_m, ONLY: press_coefoz
     USE carbon_cycle_mod, ONLY : carbon_cycle_init, carbon_cycle_tr, carbon_cycle_cpl
-
-    IMPLICIT NONE
 
     INCLUDE "indicesol.h"
@@ -78,5 +93,9 @@
     REAL,DIMENSION(klon,nbsrf),INTENT(IN)     :: pctsrf ! Pourcentage de sol f(nature du sol)
     REAL,DIMENSION(klon,nbsrf),INTENT(IN)     :: ftsol  ! Temperature du sol (surf)(Kelvin)
-    REAL,DIMENSION(klon,klev,nbtr),INTENT(IN) :: tr_seri! Concentration Traceur [U/KgA]  
+!IM traceurs RR   REAL,DIMENSION(klon,klev,nbtr),INTENT(IN) :: tr_seri! Concentration Traceur [U/KgA]  
+    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT) :: tr_seri! Concentration Traceur [U/KgA]  
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique
 
 ! Output variables
@@ -85,5 +104,6 @@
         
 ! Local variables    
-    INTEGER :: ierr, it, iiq
+    INTEGER :: ierr, it, iiq, i, k
+    REAL,DIMENSION(klon,klev)      :: qsat   ! pression de la vapeur a saturation
     
 ! --------------------------------------------
@@ -121,7 +141,8 @@
     
 !
-! Recherche des traceurs connus : Be7, CO2,...
+! Recherche des traceurs connus : Be7, O3, CO2,...
 ! --------------------------------------------
     id_be=0
+    id_o3=0
     DO it=1,nbtr
        iiq=niadv(it+2)
@@ -135,6 +156,69 @@
           CALL init_be(pctsrf,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
           WRITE(*,*) 'Initialisation srcBe: OK'
+       ELSE IF (tname(iiq)=="O3" .OR. tname(iiq)=="o3") THEN
+          ! Recherche de l'ozone : parametrization de la chimie par Cariolle
+          id_o3=it
+          CALL alloc_coefoz   ! allocate ozone coefficients
+          CALL press_coefoz   ! read input pressure levels
        END IF    
     END DO
+
+    id_dry=0
+
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       IF ( tname(iiq) == "dry" .OR. tname(iiq) == "Dry" ) THEN
+        id_dry=it
+       END IF    
+    END DO  
+
+    id_pcsat=0
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       IF ( tname(iiq) == "pcsat" .OR. tname(iiq) == "Pcsat" ) THEN
+        id_pcsat=it
+      END IF
+    END DO
+
+    id_pcocsat=0
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       IF ( tname(iiq) == "pcocsat" .OR. tname(iiq) == "Pcocsat" ) THEN
+        id_pcocsat=it
+       END IF
+    END DO
+
+    id_pcq=0
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       IF ( tname(iiq) == "pcq" .OR. tname(iiq) == "Pcq" ) THEN
+        id_pcq=it
+       END IF
+    END DO
+
+    id_pcs0=0
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       IF ( tname(iiq) == "pcs0" .OR. tname(iiq) == "Pcs0" ) THEN
+        id_pcs0=it
+      END IF
+    END DO
+
+    id_pcos0=0
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       IF ( tname(iiq) == "pcos0" .OR. tname(iiq) == "Pcos0" ) THEN
+        id_pcos0=it
+       END IF
+    END DO
+
+    id_pcq0=0
+    DO it=1,nbtr
+       iiq=niadv(it+2)
+       IF ( tname(iiq) == "pcq0" .OR. tname(iiq) == "Pcq0" ) THEN
+        id_pcq0=it
+       END IF
+    END DO
+
 !
 ! Valeurs specifiques pour les traceurs Rn222 et Pb210
@@ -159,19 +243,93 @@
     END IF
 
+!IM initialisation traceurs pseudo-vapeurs
+    call q_sat(klon*klev,t_seri,pplay,qsat)
+    IF ( id_pcsat /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcsat) = qsat(i,k)
+       ELSE
+        tr_seri(i,k,id_pcsat) = 100.
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcocsat /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        IF ( pctsrf (i, is_oce) > 0. ) THEN
+         tr_seri(i,k,id_pcocsat) = qsat(i,k)
+        ELSE
+         tr_seri(i,k,id_pcocsat) = 100.
+        END IF
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcq /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcq) = sh(i,k)
+       ELSE
+        tr_seri(i,k,id_pcq) = 100.
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcs0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcs0) = qsat(i,k)
+       ELSE
+        tr_seri(i,k,id_pcs0) = 100.
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcos0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        IF ( pctsrf (i, is_oce) > 0. ) THEN
+         tr_seri(i,k,id_pcos0) = qsat(i,k)
+        ELSE
+         tr_seri(i,k,id_pcos0) = 100.
+        END IF
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcq0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcq0) = sh(i,k)
+       ELSE
+        tr_seri(i,k,id_pcq0) = 100.
+       END IF
+      END DO
+     END DO
+    END IF
+ 
   END SUBROUTINE traclmdz_init
 
-  SUBROUTINE traclmdz(                           &
-       nstep,    pdtphys,      t_seri,           &
-       paprs,    pplay,        cdragh,  coefh,   &
-       yu1,      yv1,          ftsol,   pctsrf,  &
-       xlat,     couchelimite,                   &
-       tr_seri,  source,       solsym,  d_tr_cl)
+  SUBROUTINE traclmdz(nstep, julien, gmtime, pdtphys, t_seri, paprs, pplay, &
+       cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon, couchelimite, sh, &
+       tr_seri, source, solsym, d_tr_cl, zmasse)
     
     USE dimphy
     USE infotrac
+    USE regr_pr_comb_coefoz_m, ONLY: regr_pr_comb_coefoz
+    USE o3_chem_m, ONLY: o3_chem
     USE carbon_cycle_mod, ONLY : carbon_cycle, carbon_cycle_tr, carbon_cycle_cpl
-    
-    IMPLICIT NONE
-    
     INCLUDE "YOMCST.h"
     INCLUDE "indicesol.h"
@@ -185,6 +343,9 @@
 !Configuration grille,temps:
     INTEGER,INTENT(IN) :: nstep      ! nombre d'appels de la physiq
+    INTEGER,INTENT(IN) :: julien     ! Jour julien
+    REAL,INTENT(IN)    :: gmtime
     REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)  
     REAL,DIMENSION(klon),INTENT(IN) :: xlat    ! latitudes pour chaque point 
+    REAL, INTENT(IN):: xlon(:) ! dim(klon) longitude
 
 !
@@ -194,4 +355,5 @@
     REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
+    REAL,intent(in):: zmasse (:, :)   ! dim(klon,klev) density of air, in kg/m2
 
 
@@ -204,4 +366,6 @@
     REAL,DIMENSION(klon),INTENT(IN)      :: yv1        ! vents au premier niveau
     LOGICAL,INTENT(IN)                   :: couchelimite
+!IM traceurs RR
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique
 
 ! Arguments necessaires pour les sources et puits de traceur:
@@ -223,12 +387,13 @@
 
     INTEGER :: i, k, it
+    INTEGER lmt_pas ! number of time steps of "physics" per day
 
     REAL,DIMENSION(klon)           :: d_trs    ! Td dans le reservoir
-    REAL,DIMENSION(klon,klev)      :: delp     ! epaisseur de couche (Pa)
-    
     REAL,DIMENSION(klon,klev,nbtr) :: d_tr_dec ! Td radioactive
     REAL                           :: zrho      ! Masse Volumique de l'air KgA/m3
 
-!
+!IM traceurs RR
+    REAL,DIMENSION(klon,klev)      :: qsat   ! pression de la vapeur a saturation
+    REAL :: amn, amx
 !
 !=================================================================
@@ -245,4 +410,70 @@
     END IF
   
+!IM ajout traceurs RR
+    call q_sat(klon*klev,t_seri,pplay,qsat)
+    
+    IF ( id_pcsat /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcsat) = qsat(i,k)
+       END IF
+      END DO 
+     END DO
+    END IF
+
+    IF ( id_pcocsat /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        IF ( pctsrf (i, is_oce) > 0. ) THEN
+         tr_seri(i,k,id_pcocsat) = qsat(i,k)
+        END IF
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcq /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcq) = sh(i,k)
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcs0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcs0) = qsat(i,k)
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcos0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        IF ( pctsrf (i, is_oce) > 0. ) THEN
+         tr_seri(i,k,id_pcos0) = qsat(i,k)
+        END IF
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcq0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).GE.85000.) THEN
+        tr_seri(i,k,id_pcq0) = sh(i,k)
+       END IF
+      END DO
+     END DO
+    END IF
 
     DO it=1,nbtr
@@ -265,11 +496,4 @@
     END IF
     
-
-    DO k = 1, klev
-       DO i = 1, klon
-          delp(i,k) = paprs(i,k)-paprs(i,k+1)
-       END DO
-    END DO
-    
     DO it=1, nbtr
        IF (couchelimite .AND. pbl_flg(it) == 0 ) THEN ! couche limite avec quantite dans le sol calculee
@@ -277,5 +501,5 @@
                cdragh, coefh,t_seri,ftsol,pctsrf,  &
                tr_seri(:,:,it),trs(:,it),          &
-               paprs, pplay, delp,                 &
+               paprs, pplay, zmasse * rg, &
                masktr(:,it),fshtr(:,it),hsoltr(it),&
                tautr(it),vdeptr(it),               &
@@ -294,5 +518,65 @@
        END IF
     END DO
-           
+          
+!IM traceurs RR
+    IF ( id_pcsat /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).LT.85000.) THEN
+        tr_seri(i,k,id_pcsat) = MIN (qsat(i,k), tr_seri(i,k,id_pcsat))
+       END IF 
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcocsat /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).LT.85000.) THEN
+        tr_seri(i,k,id_pcocsat) = MIN (qsat(i,k), tr_seri(i,k,id_pcocsat))
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcq /= 0 ) THEN
+     DO k = 1, klev 
+      DO i = 1, klon 
+       IF ( pplay(i,k).LT.85000.) THEN
+        tr_seri(i,k,id_pcq) = MIN (qsat(i,k), tr_seri(i,k,id_pcq))
+       END IF
+      END DO  
+     END DO  
+    END IF  
+
+    IF ( id_pcs0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).LT.85000.) THEN
+        tr_seri(i,k,id_pcs0) = MIN (qsat(i,k), tr_seri(i,k,id_pcs0))
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcos0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).LT.85000.) THEN
+        tr_seri(i,k,id_pcos0) = MIN (qsat(i,k), tr_seri(i,k,id_pcos0))
+       END IF
+      END DO
+     END DO
+    END IF
+
+    IF ( id_pcq0 /= 0 ) THEN
+     DO k = 1, klev
+      DO i = 1, klon
+       IF ( pplay(i,k).LT.85000.) THEN
+        tr_seri(i,k,id_pcq0) = MIN (qsat(i,k), tr_seri(i,k,id_pcq0))
+       END IF
+      END DO
+     END DO
+    END IF
 !======================================================================
 !   Calcul de l'effet du puits radioactif
@@ -312,4 +596,18 @@
 
 !======================================================================
+!   Parameterization of ozone chemistry
+!======================================================================
+
+    IF (id_o3 /= 0) then
+       lmt_pas = NINT(86400./pdtphys)
+       IF (MOD(nstep - 1, lmt_pas) == 0) THEN
+          ! Once per day, update the coefficients for ozone chemistry:
+          CALL regr_pr_comb_coefoz(julien, xlat, paprs, pplay)
+       END IF
+       CALL o3_chem(julien, gmtime, t_seri, zmasse, pdtphys, xlat, &
+            xlon, tr_seri(:, :, id_o3))
+    END IF
+
+!======================================================================
 !   Calcul de cycle de carbon
 !======================================================================
@@ -327,6 +625,4 @@
     USE infotrac
     
-    IMPLICIT NONE
-    
     REAL,DIMENSION(klon,nbtr), INTENT(OUT) :: trs_out
     INTEGER :: ierr
Index: /LMDZ4/trunk/libf/phylmd/undefSTD.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/undefSTD.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/undefSTD.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE undefSTD(itap,freq_calNMC)
Index: /LMDZ4/trunk/libf/phylmd/wake.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/wake.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/wake.F	(revision 1403)
@@ -1,3 +1,6 @@
-      Subroutine WAKE (p,ph,ppi,dtime,sigd_con
+!
+! $Id$
+!
+      Subroutine WAKE (p,ph,pi,dtime,sigd_con
      :                ,te0,qe0,omgb
      :                ,dtdwn,dqdwn,amdwn,amup,dta,dqa
